=== modified file 'Makefile'
--- Makefile	2014-07-17 03:24:57 +0000
+++ Makefile	2014-08-06 20:56:55 +0000
@@ -26,7 +26,7 @@
 OPTIMIZE=-Os -fno-strict-aliasing
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.6.7
+version=1.6.8
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))

=== modified file 'NEWS'
--- NEWS	2014-07-17 03:24:57 +0000
+++ NEWS	2014-08-06 20:56:55 +0000
@@ -1,6 +1,13 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
+Version 1.6.8 (2014-08-06)
+* Client
+** Bug fix: mandos-keygen now generates working SSH checker commands.
+* Server
+** Bug fix: "mandos-monitor" now really redraws screen on Ctrl-L.
+** Now requires Python 2.7.
+
 Version 1.6.7 (2014-07-17)
 * Client
 ** Bug fix: Now compatible with GPGME 1.5.0.

=== modified file 'TODO'
--- TODO	2014-07-14 21:41:08 +0000
+++ TODO	2014-08-09 23:37:07 +0000
@@ -32,7 +32,6 @@
 ** TODO [#B] use scandir(3) instead of readdir(3)
 
 * askpass-fifo
-** TODO [#B] Drop privileges after opening FIFO.
 
 * password-prompt
 ** TODO [#B] lock stdin (with flock()?)
@@ -69,7 +68,7 @@
 ** TODO Use python-tlslite?
 ** TODO D-Bus AddClient() method on server object
 ** TODO Use org.freedesktop.DBus.Method.NoReply annotation on async methods. :2:
-** TODO Emit [[http://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces-properties][org.freedesktop.DBus.Properties.PropertiesChanged]] signal	  :2:
+** TODO Emit [[http://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces-properties][org.freedesktop.DBus.Properties.PropertiesChanged]] signal	     :2:
    TODO Deprecate se.recompile.Mandos.Client.PropertyChanged - annotate!
    TODO Can use "invalidates" annotation to also emit on changed secret.
 ** TODO Support [[http://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces-objectmanager][org.freedesktop.DBus.ObjectManager]] interface on server object :2:
@@ -79,13 +78,14 @@
 ** TODO CheckerCompleted method, deprecate CheckedOK
 ** TODO Secret Service API?
    http://standards.freedesktop.org/secret-service/
-** TODO Remove D-Bus interfaces with old domain name			  :2:
-** TODO Remove old string_to_delta format				  :2:
+** TODO Remove D-Bus interfaces with old domain name			     :2:
+** TODO Remove old string_to_delta format				     :2:
 ** TODO http://0pointer.de/blog/projects/stateless.html
 *** tmpfiles snippet to create /var/lib/mandos with right user+perms
 *** File in /usr/lib/sysusers.d to create user+group "_mandos"
 ** TODO Error handling on error parsing config files
 ** TODO init.d script error handling
+** TODO D-Bus server properties; address, port, interface, etc.		     :2:
 
 * mandos.xml
 ** Add mandos contact info in manual pages
@@ -93,7 +93,7 @@
 * mandos-ctl
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
-** TODO Remove old string_to_delta format				  :2:
+** TODO Remove old string_to_delta format				     :2:
 
 * TODO mandos-dispatch
   Listens for specified D-Bus signals and spawns shell commands with

=== modified file 'common.ent'
--- common.ent	2014-07-17 03:24:57 +0000
+++ common.ent	2014-08-06 20:56:55 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.6.7">
+<!ENTITY version "1.6.8">

=== modified file 'debian/changelog'
--- debian/changelog	2014-07-17 03:24:57 +0000
+++ debian/changelog	2014-08-06 20:56:55 +0000
@@ -1,3 +1,16 @@
+mandos (1.6.8-1) unstable; urgency=medium
+
+  * New upstream release.
+  * debian/control (Source: mandos/Build-Depends-Indep): Since upstream
+    now requires Python 2.7, depend on exactly the python2.7 package and
+    all the Python 2.7 versions of the python modules.
+    (Package: mandos/Depends): - '' - but still depend on python (>=2.7)
+    and the generic versions of the Python modules; this is for mandos-ctl
+    and mandos-monitor, both of which are compatible with Python 3, and
+    use #!/usr/bin/python.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Wed, 06 Aug 2014 22:55:24 +0200
+
 mandos (1.6.7-1) unstable; urgency=medium
 
   * New upstream release.

=== modified file 'debian/control'
--- debian/control	2014-07-25 22:44:20 +0000
+++ debian/control	2014-07-25 23:54:03 +0000
@@ -16,7 +16,7 @@
 
 Package: mandos
 Architecture: all
-Depends: ${misc:Depends}, python (<= 2.7), python2.7, python-gnutls,
+Depends: ${misc:Depends}, python (>= 2.7), python2.7, python-gnutls,
 	python2.7-gnutls, python-dbus, python2.7-dbus, python-avahi,
 	python2.7-avahi, python-gobject, python2.7-gobject,
 	avahi-daemon, adduser, python-urwid, python2.7-urwid,

=== modified file 'mandos'
--- mandos	2014-07-25 23:39:49 +0000
+++ mandos	2014-08-09 13:18:46 +0000
@@ -88,7 +88,10 @@
     except ImportError:
         SO_BINDTODEVICE = None
 
-version = "1.6.7"
+if sys.version_info.major == 2:
+    str = unicode
+
+version = "1.6.8"
 stored_state_file = "clients.pickle"
 
 logger = logging.getLogger()
@@ -104,10 +107,8 @@
         SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
         with contextlib.closing(socket.socket()) as s:
             ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
-                                struct.pack(str("16s16x"),
-                                            interface))
-        interface_index = struct.unpack(str("I"),
-                                        ifreq[16:20])[0]
+                                struct.pack(b"16s16x", interface))
+        interface_index = struct.unpack("I", ifreq[16:20])[0]
         return interface_index
 
 
@@ -118,7 +119,7 @@
     syslogger = (logging.handlers.SysLogHandler
                  (facility =
                   logging.handlers.SysLogHandler.LOG_DAEMON,
-                  address = str("/dev/log")))
+                  address = "/dev/log"))
     syslogger.setFormatter(logging.Formatter
                            ('Mandos [%(process)d]: %(levelname)s:'
                             ' %(message)s'))
@@ -224,9 +225,8 @@
 class AvahiError(Exception):
     def __init__(self, value, *args, **kwargs):
         self.value = value
-        super(AvahiError, self).__init__(value, *args, **kwargs)
-    def __unicode__(self):
-        return unicode(repr(self.value))
+        return super(AvahiError, self).__init__(value, *args,
+                                                **kwargs)
 
 class AvahiServiceError(AvahiError):
     pass
@@ -282,8 +282,8 @@
                             " after %i retries, exiting.",
                             self.rename_count)
             raise AvahiServiceError("Too many renames")
-        self.name = unicode(self.server
-                            .GetAlternativeServiceName(self.name))
+        self.name = str(self.server
+                        .GetAlternativeServiceName(self.name))
         logger.info("Changing Zeroconf service name to %r ...",
                     self.name)
         self.remove()
@@ -337,7 +337,7 @@
             self.rename()
         elif state == avahi.ENTRY_GROUP_FAILURE:
             logger.critical("Avahi: Error in group state changed %s",
-                            unicode(error))
+                            str(error))
             raise AvahiGroupError("State changed: {!s}"
                                   .format(error))
     
@@ -688,8 +688,7 @@
         if self.checker is None:
             # Escape attributes for the shell
             escaped_attrs = { attr:
-                                  re.escape(unicode(getattr(self,
-                                                            attr)))
+                                  re.escape(str(getattr(self, attr)))
                               for attr in self.runtime_expansions }
             try:
                 command = self.checker_command % escaped_attrs
@@ -831,9 +830,7 @@
 class DBusPropertyException(dbus.exceptions.DBusException):
     """A base class for D-Bus property-related exceptions
     """
-    def __unicode__(self):
-        return unicode(str(self))
-
+    pass
 
 class DBusPropertyAccessException(DBusPropertyException):
     """A property's access permissions disallows an operation.
@@ -1228,7 +1225,7 @@
         Client.__init__(self, *args, **kwargs)
         # Only now, when this client is initialized, can it show up on
         # the D-Bus
-        client_object_name = unicode(self.name).translate(
+        client_object_name = str(self.name).translate(
             {ord("."): ord("_"),
              ord("-"): ord("_")})
         self.dbus_object_path = (dbus.ObjectPath
@@ -1489,7 +1486,7 @@
     def Host_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.String(self.host)
-        self.host = unicode(value)
+        self.host = str(value)
     
     # Created - property
     @dbus_service_property(_interface, signature="s", access="read")
@@ -1593,7 +1590,7 @@
     def Checker_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.String(self.checker_command)
-        self.checker_command = unicode(value)
+        self.checker_command = str(value)
     
     # CheckerRunning - property
     @dbus_service_property(_interface, signature="b",
@@ -1615,7 +1612,7 @@
     @dbus_service_property(_interface, signature="ay",
                            access="write", byte_arrays=True)
     def Secret_dbus_property(self, value):
-        self.secret = str(value)
+        self.secret = bytes(value)
     
     del _interface
 
@@ -1655,7 +1652,7 @@
     def handle(self):
         with contextlib.closing(self.server.child_pipe) as child_pipe:
             logger.info("TCP connection from: %s",
-                        unicode(self.client_address))
+                        str(self.client_address))
             logger.debug("Pipe FD: %d",
                          self.server.child_pipe.fileno())
             
@@ -1960,7 +1957,8 @@
                 try:
                     self.socket.setsockopt(socket.SOL_SOCKET,
                                            SO_BINDTODEVICE,
-                                           str(self.interface + '\0'))
+                                           (self.interface + "\0")
+                                           .encode("utf-8"))
                 except socket.error as error:
                     if error.errno == errno.EPERM:
                         logger.error("No permission to bind to"
@@ -2226,7 +2224,7 @@
     timevalue = datetime.timedelta(0)
     for s in interval.split():
         try:
-            suffix = unicode(s[-1])
+            suffix = s[-1]
             value = int(s[:-1])
             if suffix == "d":
                 delta = datetime.timedelta(value)
@@ -2383,8 +2381,9 @@
     del options
     # Force all strings to be unicode
     for option in server_settings.keys():
-        if type(server_settings[option]) is str:
-            server_settings[option] = unicode(server_settings[option])
+        if isinstance(server_settings[option], bytes):
+            server_settings[option] = (server_settings[option]
+                                       .decode("utf-8"))
     # Force all boolean options to be boolean
     for option in ("debug", "use_dbus", "use_ipv6", "restore",
                    "foreground", "zeroconf"):
@@ -2533,7 +2532,8 @@
                                        protocol = protocol, bus = bus)
         if server_settings["interface"]:
             service.interface = (if_nametoindex
-                                 (str(server_settings["interface"])))
+                                 (server_settings["interface"]
+                                  .encode("utf-8")))
     
     global multiprocessing_manager
     multiprocessing_manager = multiprocessing.Manager()
@@ -2657,7 +2657,7 @@
             try:
                 with pidfile:
                     pid = os.getpid()
-                    pidfile.write(str(pid) + "\n".encode("utf-8"))
+                    pidfile.write("{}\n".format(pid).encode("utf-8"))
             except IOError:
                 logger.error("Could not write to file %r with PID %d",
                              pidfilename, pid)

=== modified file 'mandos-ctl'
--- mandos-ctl	2014-07-25 23:39:49 +0000
+++ mandos-ctl	2014-08-06 20:56:55 +0000
@@ -42,7 +42,7 @@
 
 import dbus
 
-if sys.version_info[0] == 2:
+if sys.version_info.major == 2:
     str = unicode
 
 locale.setlocale(locale.LC_ALL, "")
@@ -72,7 +72,7 @@
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.6.7"
+version = "1.6.8"
 
 def milliseconds_to_string(ms):
     td = datetime.timedelta(0, 0, 0, ms)

=== modified file 'mandos-keygen'
--- mandos-keygen	2014-07-17 03:24:57 +0000
+++ mandos-keygen	2014-08-06 20:56:55 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.6.7"
+VERSION="1.6.8"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=RSA
@@ -363,7 +363,7 @@
 	    }
 	}' < "$SECFILE"
     if [ -n "$ssh_fingerprint" ]; then
-	echo 'checker = ssh-keyscan %%(host)s 2>/dev/null | grep --fixed-strings --line-regexp --quiet --regexp="%%(host)s %(ssh_fingerprint)s"'
+	echo 'checker = ssh-keyscan %%(host)s 2>/dev/null | grep --fixed-strings --line-regexp --quiet --regexp=%%(host)s" %(ssh_fingerprint)s"'
 	echo "ssh_fingerprint = ${ssh_fingerprint}"
     fi
 fi

=== modified file 'mandos-monitor'
--- mandos-monitor	2014-07-25 23:32:04 +0000
+++ mandos-monitor	2014-08-06 20:56:55 +0000
@@ -48,7 +48,7 @@
 
 import locale
 
-if sys.version_info[0] == 2:
+if sys.version_info.major == 2:
     str = unicode
 
 locale.setlocale(locale.LC_ALL, '')
@@ -60,7 +60,7 @@
 domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.6.7"
+version = "1.6.8"
 
 def isoformat_to_datetime(iso):
     "Parse an ISO 8601 date string to a datetime.datetime()"

=== modified file 'mandos.lsm'
--- mandos.lsm	2014-07-17 03:24:57 +0000
+++ mandos.lsm	2014-08-06 20:56:55 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.6.7
-Entered-date:	2014-07-17
+Version:	1.6.8
+Entered-date:	2014-08-06
 Description:	The Mandos system allows computers to have encrypted
 		root file systems and at the same time be capable of
 		remote and/or unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
 Primary-site:	http://www.recompile.se/mandos
-		161K mandos_1.6.7.orig.tar.gz
+		161K mandos_1.6.8.orig.tar.gz
 Alternate-site:	ftp://ftp.recompile.se/pub/mandos
-		161K mandos_1.6.7.orig.tar.gz
+		161K mandos_1.6.8.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
 		various other libraries.  While made for Debian
 		GNU/Linux, it is probably portable to other

=== modified file 'mandos.service'
--- mandos.service	2013-12-31 16:02:18 +0000
+++ mandos.service	2014-08-06 20:33:26 +0000
@@ -6,7 +6,7 @@
 ## Type=dbus is not appropriate, because Mandos also needs to announce
 ## its ZeroConf service and be reachable on the network.
 #Type=dbus
-BusName=se.recompile.Mandos
+#BusName=se.recompile.Mandos
 # If you add --no-dbus, also comment out BusName above, and vice versa
 ExecStart=/usr/sbin/mandos --foreground
 Restart=always

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2014-03-29 02:38:15 +0000
+++ plugins.d/askpass-fifo.c	2014-08-09 23:37:07 +0000
@@ -23,7 +23,7 @@
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY() */
-#include <sys/types.h>		/* ssize_t */
+#include <sys/types.h>		/* uid_t, gid_t, ssize_t */
 #include <sys/stat.h>		/* mkfifo(), S_IRUSR, S_IWUSR */
 #include <iso646.h>		/* and */
 #include <errno.h>		/* errno, EACCES, ENOTDIR, ELOOP,
@@ -44,6 +44,8 @@
 #include <string.h> 		/* strerror() */
 #include <stdarg.h>		/* va_list, va_start(), ... */
 
+uid_t uid = 65534;
+gid_t gid = 65534;
 
 /* Function to use when printing errors */
 __attribute__((format (gnu_printf, 3, 4)))
@@ -74,6 +76,9 @@
   int ret = 0;
   ssize_t sret;
   
+  uid = getuid();
+  gid = getgid();
+  
   /* Create FIFO */
   const char passfifo[] = "/lib/cryptsetup/passfifo";
   ret = mkfifo(passfifo, S_IRUSR | S_IWUSR);
@@ -119,6 +124,16 @@
     }
   }
   
+  /* Lower group privileges  */
+  if(setgid(gid) == -1){
+    error_plus(0, errno, "setgid");
+  }
+  
+  /* Lower user privileges */
+  if(setuid(uid) == -1){
+    error_plus(0, errno, "setuid");
+  }
+  
   /* Read from FIFO */
   char *buf = NULL;
   size_t buf_len = 0;

